import cv2
import RPi.GPIO as GPIO
import Cards
import time
import numpy as np
import VideoStream
print("g")
newstack = Cards.Query_card()
newstack.center = [900, 150]    #Koordinaten des nachziehstapels
playstack = Cards.Query_card()    #Wird der eingelesenen Stapelkarte zugewiesen
reset = Cards.Query_card()
reset.center = [1100,720]            #Ruheposition des Arms

DIR = 20# Directiorn GPIO Pin
STEPX = 21#Step GPIO Pin
STEPY = 26#Step GPIO Pin
CW = 1 #Clockwise Rotation
CCW = 0 #Counterclockwise Rotation
SPRX = 200
SPRY = 400
PUMP = 16 #Pumpenpin
SERVO = 18

posx = 1100 #Position des wagens
posy = 720 #Position des Arms
holding = 0 #Ob der arm eine Karte hält

GPIO.setmode(GPIO.BCM)
GPIO.setup(PUMP, GPIO.OUT)
GPIO.setup(DIR, GPIO.OUT)
GPIO.setup(STEPX, GPIO.OUT)
GPIO.setup(STEPY, GPIO.OUT)
GPIO.setup(SERVO, GPIO.OUT)
GPIO.output(DIR, CW)

servo = GPIO.PWM(SERVO, 50)

delayX = 0.005
delayY = 0.0025





def PlayCard(hand):
    updatePos()
    print("Finding card to play")
    for i in range(len(hand)):
        if (hand[i].rankval == playstack.rankval or hand[i].suitval == playstack.suitval):
            play(hand[i])
            return
    take(newstack)



def play(card):
    print("Playing")
    moveto(card)
    pickup()            #nimm karte setze holding auf 1
    moveto(playstack)
    pickup()            #leg karte wieder ab, da holding jetzt 1  ist und setze holding wieder auf 0
    moveto(reset)
    return


def take(newstack):
    #nimm neue karte und finde freien Platz
    print("roboter muss ziehen")
    return





def moveto(posCard):
    
    global  posx
    print("Moving")
    print(posCard.center)

    while True:
        posdeltaX = posx -posCard.center[0]
        print(int(posdeltaX/2.5))
        if posdeltaX < 0:
            posdeltaX *= -1
            GPIO.output(DIR, CW)
            setPosX(int(posdeltaX/2.5))
        elif posdeltaX > 0:
            GPIO.output(DIR, CCW)
            setPosX(int(posdeltaX/2.5))
        updatePos()
        if (posx - posCard.center[0] < 10 and posx - posCard.center[0] > -10):
            break
        
    print("reachedx")
    global posy
    while True:
        posdeltaY = posy - posCard.center[1]
        print(int(posdeltaY*3.5))
        if posdeltaY < 0:
            posdeltaY*= -1
            GPIO.output(DIR, CCW)
            setPosY(int(posdeltaY*3.5))
        elif posdeltaY > 0:
            GPIO.output(DIR, CW)
            setPosY(int(posdeltaY*3.5))
        updatePos()
        if (posy - posCard.center[1] < 10 and posy - posCard.center[1] > -10):
            break
    print("reachedy")
    return

def pickup():
    servo.start(6.2)
    if (holding == 0):
        servo.ChangeDutyCycle(6.1)
        GPIO.output(PUMP, GPIO.HIGH)
        time.sleep(10)
    else:
        servo.ChangeDutyCycle(6.2)
        time.sleep(5)
        GPIO.output(PUMP, GPIO.LOW)

    return

def setPosX(target):
    for x in range(target):
        GPIO.output(STEPX, GPIO.HIGH)
        time.sleep(delayX)
        GPIO.output(STEPX, GPIO.LOW)
        time.sleep(delayX)
    return

def setPosY(target):
    for x in range(target):
        GPIO.output(STEPY, GPIO.HIGH)
        time.sleep(delayY)
        GPIO.output(STEPY, GPIO.LOW)
        time.sleep(delayY)
    return

def updatePos():
    
    global posx
    global posy
    
    lowerBound=np.array([30,80,40])
    upperBound=np.array([100,255,255])
    cam = cv2.VideoCapture(0)
    cam.set(cv2.CAP_PROP_FRAME_WIDTH, 1280)
    cam.set(cv2.CAP_PROP_FRAME_HEIGHT, 720)
    
    ret, image = cam.read()
    
    cam.release()
    imageHSV = cv2.cvtColor(image,cv2.COLOR_BGR2HSV)
    mask = cv2.inRange(imageHSV, lowerBound, upperBound)
    dummy,gcnts,h = cv2.findContours(mask.copy(), cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_NONE)
    if len(gcnts) != 0:
        mark = max(gcnts, key = cv2.contourArea)
        cv2.drawContours(imageHSV,mark,-1,(255,0,0),5)
        cv2.imshow("track",imageHSV)
        x,y,w,h = cv2.boundingRect(mark)
        posx = (int)(x+(0.5*w))
        posy = (int)(y+(0.5*h))
    return